<?php

namespace Drupal\groupmedia\Plugin\Group\RelationHandler;

use Drupal\group\Plugin\Group\RelationHandler\PermissionProviderInterface;
use Drupal\group\Plugin\Group\RelationHandler\PermissionProviderTrait;

/**
 * Provides group permissions for the group_media relation plugin.
 */
class GroupMediaPermissionProvider implements PermissionProviderInterface {

  use PermissionProviderTrait;

  /**
   * Constructs a new GroupMediaPermissionProvider.
   *
   * @param \Drupal\group\Plugin\Group\RelationHandler\PermissionProviderInterface $parent
   *   The default permission provider.
   */
  public function __construct(PermissionProviderInterface $parent) {
    $this->parent = $parent;
  }

  /**
   * {@inheritdoc}
   */
  public function getPermission($operation, $target, $scope = 'any') {
    if ($target === 'relationship') {
      if ($operation === 'delete') {
        return "$operation $scope invitation";
      }
      if ($operation === 'create') {
        return 'invite users to group';
      }
      if ($operation === 'view') {
        return 'view group invitations';
      }
      if ($operation === 'update') {
        return FALSE;
      }
    }
    return $this->parent->getPermission($operation, $target, $scope);

  }

}
